do
    local CBFP_oldModBlueprints = ModBlueprints
    function ModBlueprints(all_bps)
        CBFP_oldModBlueprints(all_bps)
        for id, bp in all_bps.Unit do
            if not bp.ResolvePath then # skip blueprints that don't have this set for perfomance reasons
                continue
            end
            bp = ResolvePaths(bp)
        end
    end

    # finds a path that starts with [...] , finds the specified file and then corrects the path
    function ResolvePaths(bpTable)
        for k, v in bpTable do
            if type(v) == 'table' then
                bpTable[k] = ResolvePaths(v)
                continue
            elseif type(v) != 'string' or string.len(v) < 8 or string.sub(v, 1, 5) != '[...]' then
                continue
            end
            local partialPath = string.sub(v, 6) # v needs to be > 6 for this, checking v >= 8 two lines up
            local path = ''
            local foundResult = false
            LOG('Resolving full path for '..repr(partialPath))
            for i, m in __active_mods do
                for _,file in DiskFindFiles(m.location, partialPath) do
                    path = file
                    foundResult = true
                    break
                end
                if foundResult then
                    break
                end
            end
            if not foundResult then
                WARN('Cannot resolve full path for partial path '..repr(partialPath))
                continue
            end
            bpTable[k] = path
        end
        return bpTable
    end
end
-- T3 modify
-- Author: Quezalcoalt
--
-- Description:
--    Sample Mod to modify the price of T3 Units
--


--this function is called already in game. This gives us a hook to screw the 
--blueprint values for the units

do
    local overridden = ModBlueprints

    function ModBlueprints(blueprints)
	    overridden(blueprints)

        local valeur1 = 0.67 
		local valeur2 = 0.50
		local valeur3 = 0.33
		local valeur4 = 0.25
		local valeur5 = 0.80
	        
        --loop through the blueprints and adjust as desired.
        for id,bp in blueprints.Unit do
			if table.find(bp.Categories,'MASSFABRICATION') then
				if bp.Economy.ProductionPerSecondMass then
				bp.Economy.ProductionPerSecondMass = bp.Economy.ProductionPerSecondMass * 2
				end
			end
		    if table.find(bp.Categories,'TECH3') then
				if table.find(bp.Categories,'STRUCTURE') then
					if table.find(bp.Categories,'ARTILLERY') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur4
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur4
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur4
						end
					end
					if table.find(bp.Categories,'ANTIAIR') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur1
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur1
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur1
						end
					end
				end
				if table.find(bp.Categories,'LAND') then
					if table.find(bp.Categories,'MOBILE') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur1
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur1
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur1
						end
					end
				end	
				if table.find(bp.Categories,'NAVAL') then
					if table.find(bp.Categories,'MOBILE') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur2
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur2
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur2
						end
					end
				end
				if table.find(bp.Categories,'AIR') then
					if table.find(bp.Categories,'ANTIAIR') then
						if table.find(bp.Categories,'HIGHALTAIR') then
							if bp.Defense.Health then
							bp.Defense.Health = bp.Defense.Health * valeur5
							end
							if bp.Defense.MaxHealth then
							bp.Defense.MaxHealth = bp.Defense.MaxHealth * valeur5
							end
						end
					end
				end
			end
			if table.find(bp.Categories,'TECH2') then
				if table.find(bp.Categories,'AIR') then
					if table.find(bp.Categories,'GROUNDATTACK') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur1
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur1
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur1
						end
					
					end
				end
				if table.find(bp.Categories,'STRUCTURE') then
					if table.find(bp.Categories,'ARTILLERY') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur2
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur2
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur2
						end
						if bp.Defense.Health then
						bp.Defense.Health = bp.Defense.Health * valeur3
						end
						if bp.Defense.MaxHealth then
						bp.Defense.MaxHealth = bp.Defense.MaxHealth * valeur3
						end
					end
					if table.find(bp.Categories,'COUNTERINTELLIGENCE') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur2
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur2
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur2
						end
					end
					if table.find(bp.Categories,'FACTORY') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur2
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur2
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur2
						end
					end
				end
				if table.find(bp.Categories,'LAND') then
					if table.find(bp.Categories,'INDIRECTFIRE') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur1
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur1
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur1
						end
					end
				end
			end
			if table.find(bp.Categories,'TECH1') then
				if table.find(bp.Categories,'AIR') then
						if table.find(bp.Categories,'BOMBER') then
						if bp.Economy.BuildCostEnergy then
						bp.Economy.BuildCostEnergy = bp.Economy.BuildCostEnergy * valeur1
						end
						if bp.Economy.BuildCostMass then
						bp.Economy.BuildCostMass = bp.Economy.BuildCostMass * valeur1
						end
						if bp.Economy.BuildTime then
						bp.Economy.BuildTime = bp.Economy.BuildTime * valeur1
						end
					end
				end
			end
		end
	end
end







